var im = require('imagemagick'),
http = require('http'),
fs = require('fs'),
Url = require('url'),
loadRequest = require('../io/net').loadRequest;


exports.getImageSize = function(url, callback)
{

	var urlParts = Url.parse(url),
	tmpDir = '/tmp/image-sizing',
	ws,
	fileType;
	
	try
	{
		fs.mkdirSync(tmpdir, 0777);
	}
	catch(e)
	{
		// console.log(e.stack)
	}
	
	
	loadRequest(url, {
		encoding:'binary',
		response: function(res)
		{
			if(res.statusCode == 200)
			{
				var contentType = res.headers['content-type'] || '';
				fileType = contentType.match(/\/(\w+)/);
				
				if(fileType)
				{
					fileType = fileType[1];
				}
				else
				{
					fileType = urlParts.pathname.split('.').pop().match(/\w+/);
					
					
					if(fileType)
					{
						fileType = fileType[0];
					}
					else
					{
						return callback(null);
					}
				}
				
				outputPath = tmpDir + '/' + (new Date().getTime() + '.' + Math.round(Math.random()*9999999) + '.' + fileType);
				
				ws = fs.createWriteStream(outputPath, {flags: 'w+'});
			}
		},
		data: function(data)
		{
			if(ws) ws.write(data, 'binary');
		},
		end: function()
		{
			if(ws) ws.end();

			var t = new Date().getTime();
			
			try
			{
				fs.lstatSync(outputPath);
			}
			catch(e)
			{
				return callback(null);
			}
			
			
			im.identify(outputPath, function(err, result)
			{
				
				console.log(outputPath)
				console.log(err)
				
				if(err) console.error(err);
				
				try
				{
					fs.unlinkSync(outputPath);
				}catch(e)
				{
					
				}
				console.log(result)
				
				callback(result);
			})
		}
	});
}

exports.getImageSize('http://web.appstorm.net/wp-content/uploads/2011/07/question.png', function(result)
{
	console.log(result)
})
